;//////////////////////////////////////////////////////////////////////////////
; - 4  DS1820                        m16term4ds1820Lcd
;//////////////////////////////////////////////////////////////////////////////
; 08.06.06	  
; 11.06.06	  lcdprintf
; 12.06.06	oss_keyinp
; 15.06.06	  
; 16.06.06	   
; 17.06.06	------------------------------
; 18.06.06	lcdprintt,
; 21.06.06	    
; 22.06.06	,  eeprom
; 23.06.06	   
; 24.06.06	 /   eeprom
; 26.06.06	  
; 27.06.06	tiny2313     ,  
;		-   t2313  -      m8
; 28.06.06	   , ,
;		 .
; 29.06.06	   0.. - 0.5 
; 30.06.06	  
; 01.07.06	------
; 02.07.06	         
;		    .
; 03.07.06	     8.   
; 06.07.06	  
; 07.07.06	   dsload   -  
; 08.07.06	  dsinit0..3
; 18.07.06	   dsload-  
; 19.07.06	dsload-  
; 20.07.06	  rele  testhyst- 
; 21.07.06	 -    . 
; 24.07.06	 m_rele_s, m_rele_p, r_fsmi
; 25.07.06	  testhyst
; 26.07.06	  
;//////////////////////////////////////////////////////////////////////////////
; / :
; PA0 -    
; PA1 - 
; PA2 - 
; PA3 -  
; PA4 -  
; PA5 -  
; PA6 -  
; PA7 -  
;
; PC0 - D4(11)LCD
; PC1 - D5(12)LCD
; PC2 - D6(13)LCD
; PC3 - D7(14)LCD
; PC4 - RS(4) LCD
; PC5 - E (6) LCD
; PC6 - 
; PC7 - 
;
; PD0 - I/O DT1
; PD1 - I/O DT2
; PD2 - I/O DT3
; PD3 - I/O DT4
; PD4 -    1
; PD5 -    2
; PD6 -    3
; PD7 -    4
;
; PB0 - 
; PB1 - 
; PB2 - 
; PB3 -  OC0     LCD
; PB4 - 
; PB5 - 
; PB6 - 
; PB7 - 

;//////////////////////////////////////////////////////////////////////////////
.include	"m16def.inc"
.def		status	=r2		; SREG
.def		mask	=r3		; 
.def		zero	=r4		;  
.def		one	=r5		;  1
.def		rss	=r6		;  
.def		ffh	=r7		;  $ff
.def		tmp0	=r13		;
.def		tmp1	=r14		; 
.def		tmp2	=r15		;
.def		temp	=r16		;
.def		temp1	=r17		;
.def		temp2	=r18		;
.def		temp3	=r19		;
.def		temp4	=r20		;
.def		post	=r21		;  
.def		AL	=r22		;
.def		AH	=r23		;
.def		BL	=r24		;
.def		BH	=r25		;
.equ		rambeg	=$0060		; 	
;//////////////////////////////////////////////////////////////////////////////
;osrshadow:	  OSR
;oss_keyinp:	 
;osrinit_t0:	   OSR0, PWM
;portinit:	 
;lcdreset:	 LCD
;lcdcom:	   LCD
;lcddat:	   LCD
;lcdprintf:	   LCD
;lcdprintt:	   LCD .
;w100us:	 100 
;w300us:	 300 	
;w02s:		 0.2 
;w01s:		 0.1 c
;w25ms:		 25 
;dsinit0:	  DS1820 DT0
;dsinit1:	  DS1820 DT1
;dsinit2:	  DS1820 DT2
;dsinit3:	  DS1820 DT3
;dsread0:	   DS1820 DT0
;dsread1:	   DS1820 DT1
;dsread2:	   DS1820 DT2
;dsread3:	   DS1820 DT3
;dswrite0:	   DS1820 DT0
;dswrite1:	   DS1820 DT1 
;dswrite2:	   DS1820 DT2
;dswrite3:	   DS1820 DT3
;dsload:	 4-       SRAM
;bin2bcd16:	 HEX - BCD
;mlb2lts:	  MLB->LTS
;lts2mlb:	  LTS->MLB
;menu:		 
;keyoff:	  
;keyof:		  ,  
;anykey:	   
;clear:		 
;menusave:	      EEPROM
;menuload:	    EEPROM
;inithyst:	     
;testhyst:	    
;releinit:	  
;rele:		 
;reset:		  
;domain:	 
;//////////////////////////////////////////////////////////////////////////////
.eseg
.org		$0000			; EEPROM
;  
contrast:	.db	227,255		; 
em_rele_s:	.db	0,0,0,0		;  1-4
em_rele_p:	.db	0,0,0,0		;  1-4
em_nn_l:	.db	110,110,110,110	; 
em_nn_h:	.db	0,0,0,0
em_nv_l:	.db	110,110,110,110	; 
em_nv_h:	.db	0,0,0,0
em_vn_l:	.db	110,110,110,110	; 
em_vn_h:	.db	0,0,0,0
em_vv_l:	.db	110,110,110,110	; 
em_vv_h:	.db	0,0,0,0
;//////////////////////////////////////////////////////////////////////////////
.dseg
.org		RAMBEG
;  
watch:		.byte	1		;
;  oss_keyinp:
k_st0:		.byte	1		;16- 
k_key0:		.byte	1		; 
k_res0:		.byte	1		; 
k_temp0:	.byte	1		;
k_fsmi:		.byte	1		; 
;;  keyof:
key_f:		.byte	1		; 
;  lcdprintf:
lpr_x:		.byte	1               ;   (0..15)
lpr_y:		.byte	1               ;  (0-,1-)
lpr_n:		.byte	1               ;  
;  lcdprintt:
lpt_x:		.byte	1		;  0..15
lpt_y:		.byte	1		; y 0,1
;  menu:
m_rele_num:	.byte	1		;     .
					;  
m_rele_s:	.byte	4		;  1-4
m_rele_p:	.byte	4		;  1-4
m_nn_l:		.byte	4		; 
m_nn_h:		.byte	4
m_nv_l:		.byte	4		; 
m_nv_h:		.byte	4
m_vn_l:		.byte	4		; 
m_vn_h:		.byte	4
m_vv_l:		.byte	4		; 
m_vv_h:		.byte	4
;  testhyst:  inithyst:
h_f0:		.byte	1		;  1 [0- 1- , 2- ]
h_f1:		.byte	1		;  2
h_f2:		.byte	1		;  3
h_f3:		.byte	1		;  4
r_fsmi:		.byte	1		;  
;r_fsmi(x,x,x,x,re3,re2,re1,re0)-   
;  dsload:
dt0:		.byte	2		;l:h    LTS
dt1:		.byte	2		;
dt2:		.byte	2		;
dt3:		.byte	2		;
d_fsmi:		.byte	1		;
;d_fsmi(x,x,x,x,d3,d2,d1,d0)- (=1  , 0- .
;----------------------------
send:		.byte	1		;  . SRAM
;//////////////////////////////////////////////////////////////////////////////
.cseg	
.org		$0000			;Internal Reset Vector Address
		jmp	reset	
.org		INT0addr		;External Interrupt0 Vector Address
		reti
.org		INT1addr		;External Interrupt1 Vector Address
		reti
.org		OC2addr			;Output Compare2 Interrupt Vector Address
		reti
.org		OVF2addr		;Overflow2 Interrupt Vector Address
		reti
.org		ICP1addr		;Input Capture1 Interrupt Vector Address
		reti
.org		OC1Aaddr		;Output Compare1A Interrupt Vector Address	
		reti
.org		OC1Baddr		;Output Compare1B Interrupt Vector Address
		reti
.org		OVF1addr		;Overflow1 Interrupt Vector Address
		reti
.org		OVF0addr		;Overflow0 Interrupt Vector Address
		jmp	osrshadow	;OSR
.org		SPIaddr			;SPI Interrupt Vector Address
		reti
.org		URXCaddr		;UART Receive Complete Interrupt Vector Address
		reti
.org		UDREaddr		;UART Data Register Empty Interrupt Vector Address
		reti
.org		UTXCaddr		;UART Transmit Complete Interrupt Vector Address
		reti
.org		ADCCaddr		;ADC Interrupt Vector Address
		reti	        	;ADC
.org		ERDYaddr		;EEPROM Interrupt Vector Address
		reti
.org		ACIaddr			;Analog Comparator Interrupt Vector Address
		reti
.org    	TWIaddr			;Irq. vector address for Two-Wire Interface
		reti
.org		INT2addr		;External Interrupt2 Vector Address
		reti
.org		OC0addr			;Output Compare0 Interrupt Vector Address
		reti
.org		SPMRaddr		;Store Program Memory Ready Interrupt Vector Address
		reti
;//////////////////////////////////////////////////////////////////////////////
;  OSR0
;  :  OVF0addr,POST
;  : ---
;  : --- (  )
;//////////////////////////////////////////////////////////////////////////////
;POST(x,x,x,x,x,x,x,keyinp)
.equ		keyinp	=0		;0- 
osrshadow:	in	status,SREG
		sbrc	post,keyinp
		call	oss_keyinp		;  
		out	SREG,status	
		reti
;//////////////////////////////////////////////////////////////////////////////
; OSS_KEYINP  a 
;  :  
;  :  k_res0:
;  0 -        4 - 
;  1 -       5 - 
;  2 -         6 -  
;  3 -        7 -  
;  0   
;//////////////////////////////////////////////////////////////////////////////
;  DSEG:
;;  oss_keyinp
;;k_st0:	.byte	1		;16- 
;;k_key0:	.byte	1		; 
;;k_res0:	.byte	1		; 
;;k_temp0:	.byte	1		;
;;k_fsmi:	.byte	1		; 
.equ		keycase	=250		;  OSR
oss_keyinp:	push	temp
		push	temp1
;!!!!      k_key0  :
; 0 -        4 - 
; 1 -       5 - 
; 2 -         6 -  
; 3 -        7 -  
; 0   
		in 	temp,pina	;   
	; : pa3-,pa4-,pa5-,
	;                      pa6-,pa7-
		swap	temp		;  
		bst	temp,7		; 
		bld	temp,4		;  4
		ori	temp,0b11100000 ; 
		sts	k_key0,temp	;  
;      
;  ,   k_key0  k_res0	
		lds	temp,k_key0	
		lds	temp1,k_res0	;
		cp	temp,temp1	;k_res0 = t_key0
		breq	oss_keyinp0	;  - 0
		lds	temp1,k_temp0	;, 
		cp	temp,temp1	;k_temp0=t_key0
		breq	oss_keyinp1	;  -  1
		sts	k_st0,zero	; k_st=0
		sts	k_temp0,temp	;k_temp0=t_key0
		jmp	oss_keyinp2	
oss_keyinp0:	sts	k_st0,zero	;k_st0=0
		jmp	oss_keyinp3	
oss_keyinp1:	lds	temp,k_st0	;k_st0++
		inc	temp	
		sts	k_st0,temp	;  
oss_keyinp2:	ldi	temp,keycase	
		lds	temp1,k_st0	
		cp	temp1,temp	;k_st0=keycase
		brne	oss_keyinp3	; 3
		lds	temp,k_temp0	; k_res0=k_temp0
		sts	k_res0,temp	
oss_keyinp3:	pop	temp1
		pop	temp
		ret
;//////////////////////////////////////////////////////////////////////////////
;  OSR  MEGA16
;  : ----
;  :    OSR
;  : temp
;  : TIMSK,TCCR0,TCNT0
;//////////////////////////////////////////////////////////////////////////////
.equ		shdwcnt	=0		; 
.equ		shdwccr	=1		; /1
osrinit_t0:	
;  oc0
		in	temp,ddrb
		sbr	temp,(1<<pb3)
		out	ddrb,temp
; 
		ldi	temp,0b01111000	;Fast PWM,ComN=3
		ldi	temp1,low(shdwccr)
		andi	temp1,0b00000111;
		or	temp,temp1	;
		out	tccr0,temp	;
; ocie0,  toie0
		in	temp,timsk
		cbr	temp,(1<<ocie0)	;
		sbr	temp,(1<<toie0)	;
		out	timsk,temp
; tcnt0
		ldi	temp,low(shdwcnt); 0
		out	tcnt0,temp	; 
; 
		ldi	temp,$ff
		out	ocr0,temp	;ff-  
		ret
;//////////////////////////////////////////////////////////////////////////////
;  
;//////////////////////////////////////////////////////////////////////////////
portinit:	push 	temp
; A		
		ldi	temp,0b00000000
		out	ddra,temp
		ldi	temp,0b11111000 ; 
		out	porta,temp
; D
		ldi	temp,0b00000000	;
		out	ddrd,temp
		ldi	temp,0b00000000
		out	portd,temp
; C		LCD
; B	
		ldi	temp,0b00000000	; 
		out	ddrb,temp
		ldi	temp,0b00000000
		out	portb,temp
		
		pop	temp
		ret
;//////////////////////////////////////////////////////////////////////////////
;  LCD
;    
;  : 
; PC0-----D4(11) 			
; PC1-----D5(12)   
; PC2-----D6(13)
; PC3-----D7(14)    
; PC4-----RS(4)     
; PC5-----E (6)
; GND-----RW(5)
; GND-----GND(1)
; VCC-----VCC(2)
;regU-----VD (3)   
;//////////////////////////////////////////////////////////////////////////////		
lcdreset:	push	temp		;   
	; 
		ldi	temp,0b00111111	;DEBUG
		out	ddrc,temp
		ldi	temp,0b00000000
		out	portc,temp
	; LCD	
		ser	temp		;  c
		out	ddrc,temp	;   
		ldi	temp,$28	; 4,2,57
		call	lcdcom		;
		call	w01s
		ldi	temp,$0c	;  , 
		call	lcdcom		;
		call	w01s
		ldi	temp,$28	; 4,2,57
		call	lcdcom		;
		call	w01s
		ldi	temp,$01	;  
		call	lcdcom		;
		call	w01s
		pop	temp		;  
		ret	
;//////////////////////////////////////////////////////////////////////////////
;    LCD
; temp- 
;//////////////////////////////////////////////////////////////////////////////
lcdcom:		push	temp
		push	temp1		;   
		swap	temp		;    
		push	temp		;    
		andi	temp,$ef	; 
		ori	temp,$e0	;   
		out	portc,r16	;   
		cbi	portc,5		;   
		pop	temp		;  
		swap	temp		;   
		andi	temp,$ef	;
		ori	temp,$e0	;   
		out	portc,temp	;   
		cbi	portc,5		;   
		ldi	temp,24		;   
		ser	temp1		;   1.6 ms
lcdcomw:	dec	temp1		;   
		brne	lcdcomw		; LCD 
		dec	temp		;
		brne	lcdcomw		;
		pop	temp1		;  
		pop	temp
		ret 
;//////////////////////////////////////////////////////////////////////////////
;    LCD
; temp- 
;//////////////////////////////////////////////////////////////////////////////
lcddat:		push	temp
		push	temp1		;   
		swap	temp
		push	temp		;  
		ori	temp,$f0	;   
		out	portc,temp	;   
		cbi	portc,5		;   
		pop	temp		;   
		swap	temp		;   
		ori	temp,$f0	;   
		out	portc,temp	;   
		cbi	portc,5		;   
		ldi	temp1,6		;    
		ldi	temp,255	;    
lcddatw:	dec	temp		;    
		brne	lcddatw		;  40 
		dec	temp1		;
		brne	lcddatw		;
		pop	temp1		;   
		pop	temp
		ret	
;//////////////////////////////////////////////////////////////////////////////
; LCDPRINTF    LCD  FLASH
;  : lpr_x -    (0..15)
;                 lpr_y -  (0-,1-)
;                 lpr_n -      ( 1..16)
;                 zl,zh -     flash
; LCDPRINTF [X-],[Y-],[ ],[  db] 
; : lcdcom,lcddat
;//////////////////////////////////////////////////////////////////////////////
;  DSEG:
;;  lcdprintf
;;lpr_x		.byte	1               ;   (0..15)
;;lpr_y		.byte	1               ;  (0-,1-)
;;lpr_n		.byte	1               ;  
.macro	lcdprintf
		ldi	temp,@0		; 0
		sts	lpr_x,temp	;X
		ldi	temp,@1		; 1
		sts	lpr_y,temp	;Y
		ldi	temp,@2		; 2
		sts	lpr_n,temp	;N
		ldi	zl,low(@3*2)	; 3
		ldi	zh,high(@3*2)	;
		call	lcd_printf	;
.endm	
.equ		lcdprintf_beg0	=128	;    0 lcd
.equ		lcdprintf_beg1	=192	;    1 lcd
lcd_printf:	
		push	zl
		push	zh
		push	temp
		push	temp1
		push	r0
	; 
		lds	temp1,lpr_y	; 
		tst	temp1		; 
		breq	lcdprintf_01	; 0 -> 01
		ldi	temp,lcdprintf_beg1;  1
		jmp	lcdprintf_02
lcdprintf_01:	ldi	temp,lcdprintf_beg0;  0				
lcdprintf_02:
	;   
		lds	temp1,lpr_x	;  
		add	temp,temp1	;  
		call	lcdcom		;  
	;  
		lds	temp1,lpr_n	;  
lcdprintf_03:	lpm			;  Flash
		mov	temp,r0		; lcddat   temp
		call	lcddat		; 
		adiw	zl,1		;  flash
		dec	temp1		; -1
		brne	lcdprintf_03	;    , 
	;
		pop	r0
		pop	temp1
		pop	temp
		pop	zh
		pop	zl
		ret
;//////////////////////////////////////////////////////////////////////////////
;    LCD.     
; [-][d2][d1][.][d0][`][C]  [d3][d2][d1][.][d0][`][C]
;  : lpt_x -    x
;                 lpt_y -    y
;                 temp2 -  LSB -    0.5 
;                 temp3 -  MSB - (=0)- ,(>0)-..
;//////////////////////////////////////////////////////////////////////////////
;  DSEG:
;;  lcdprintt
;;lpt_x:	.byte	1		;  0..15
;;lpt_y:	.byte	1		; y 0,1
.equ		lcdprintt_beg0	=128	;    0 lcd
.equ		lcdprintt_beg1	=192	;    1 lcd
lcdprintt:	push	temp
		push	temp1
		push	temp2
		push	temp3
	; 
		lds	temp1,lpt_y	; 
		tst	temp1		; 
		breq	lcdprintt_01	; 0 -> 01
		ldi	temp,lcdprintt_beg1;  1
		jmp	lcdprintt_02
lcdprintt_01:	ldi	temp,lcdprintt_beg0;  0				
lcdprintt_02:
	;   
		lds	temp1,lpt_x	;  
		add	temp,temp1	;  
		call	lcdcom		;  
	;, MSB=0-, 128-
		tst	temp3		; MSB  
		breq	lcdprintt_03	;
		cpi	temp3,128	;   
		breq	lcdprintt_04	;
	;
lcdprintt_03:	push	temp2
	; 
		lsr	temp2		;  
		mov 	xl,temp2	; x     BCD
		clr	xh
		call	bin2bcd16	;  BCD
	;  3 
		mov	temp,tmp1	;  
		andi	temp,0b00001111	;
		tst	temp		;  
		brne	lcdprintt_033	; 
		ldi	temp,251	;(239)'+48'=32'-; (251)'+48'=43'-
lcdprintt_033:	subi	temp,-48	;  
		pop	temp2		; 
		tst	temp2		;  
		brne	lcdprntt_034
		ldi	temp,' '	;	
lcdprntt_034:	push	temp2
		call	lcddat		;
		jmp	lcdprintt_05	;	
	; 
lcdprintt_04:	ldi	temp,'-'	; 
		call	lcddat		;  
	; 
		com	temp2		;
		inc	temp2
		push	temp2
		lsr	temp2		;  
		mov 	xl,temp2	; x     BCD
		clr	xh
		call	bin2bcd16	;  BCD
	;  2 
lcdprintt_05:	clr	tmp2		; 
		mov	temp,tmp1	;   
		andi	temp,0b00001111	;
		add	tmp2,temp	; 
		mov	temp,tmp0	; 2   
		swap	temp		;tmp
		andi	temp,0b00001111	; 
		add	tmp2,temp	; 
		tst	tmp2		; 
		brne	lcdprintt_055	;  ,     
		ldi	temp,239	;  ,   32() 
lcdprintt_055:	subi	temp,-48	;   
		call	lcddat		;  2
	;  1 	
		mov	temp,tmp0	;
		andi	temp,0b00001111	;
		subi	temp,-48	;   
		call	lcddat		; 	
	; 
		ldi	temp,'.'
		call	lcddat		;
	; 
		pop	temp2
		andi	temp2,0b00000001;
		tst	temp2		; LSB  
		breq	lcdprintt_07	;-    
		ldi	temp,'5'	; 
		call	lcddat		; 
		jmp	lcdprintt_08	;
lcdprintt_07:	ldi	temp,'0'	; 
		call	lcddat		;
	;   .     G- 2
lcdprintt_08:	ldi	temp,2		;  
		call	lcddat		; 
		ldi	temp,'C'	;
		call	lcddat		; 		
	;
lcdprintt_ex:	pop	temp3
		pop	temp2
		pop	temp1
		pop	temp
		ret
;//////////////////////////////////////////////////////////////////////////////
;  100 
;//////////////////////////////////////////////////////////////////////////////
w100us:		push	temp
		ser	temp
w100us_rew:	dec	temp
		brne	w100us_rew
		pop	temp
		ret
;//////////////////////////////////////////////////////////////////////////////
;  300 
;//////////////////////////////////////////////////////////////////////////////
w300us:	
		push	temp
		push	temp1
		ser	temp
		ldi	temp1,3
w300us_rew:	dec	temp
		brne	w300us_rew
		dec	temp1
		brne	w300us_rew
		pop	temp1
		pop	temp
		ret	
;//////////////////////////////////////////////////////////////////////////////
;  0.2 
;//////////////////////////////////////////////////////////////////////////////
w02s:		push	temp
		push	temp1
		push	temp2
		ser	temp
		ser	temp1
		ldi	temp2,8
w02s_rew:	dec	temp
		brne	w02s_rew
		dec	temp1
		brne	w02s_rew
		dec	temp2
		brne	w02s_rew
		pop	temp2
		pop	temp1
		pop	temp
		ret
;//////////////////////////////////////////////////////////////////////////////
;  0.1 
;//////////////////////////////////////////////////////////////////////////////
w01s:		push	temp
		push	temp1
		push	temp2
		ser	temp
		ser	temp1
		ldi	temp2,4
w01s_rew:	dec	temp
		brne	w01s_rew
		dec	temp1
		brne	w01s_rew
		dec	temp2
		brne	w01s_rew
		pop	temp2
		pop	temp1
		pop	temp
		ret
;//////////////////////////////////////////////////////////////////////////////
;  25mS 
;//////////////////////////////////////////////////////////////////////////////
w25ms:		push	temp
		push	temp1
		ser	temp
		ser	temp1
w25ms_1:	dec	temp
		brne	w25ms_1
		dec	temp1
		brne	w25ms_1
		pop	temp1
		pop	temp
		ret
;//////////////////////////////////////////////////////////////////////////////
;  4-x  DS1820 (8)
;  :---
;  :temp=$ff->  
;//////////////////////////////////////////////////////////////////////////////
;   1
.equ		ds0port	=portd		;
.equ		ds0ddr	=ddrd		; 
.equ		ds0pin	=pind		;
.equ		ds0io	=pd0		;  
;    2
.equ		ds1port	=portd		;
.equ		ds1ddr	=ddrd		; 
.equ		ds1pin	=pind		;
.equ		ds1io	=pd1		;  
;    3
.equ		ds2port	=portd		;
.equ		ds2ddr	=ddrd		; 
.equ		ds2pin	=pind		;
.equ		ds2io	=pd2		;  
;    4
.equ		ds3port	=portd		;
.equ		ds3ddr	=ddrd		; 
.equ		ds3pin	=pind		;
.equ		ds3io	=pd3		;  
dsinit0:	cli
		clr	temp		;temp=0
		cbi	ds0ddr,ds0io	;   Z
		sbis	ds0pin,ds0io	;  I/O
		reti			;   -
		sbi	ds0ddr,ds0io	; 
		cbi	ds0port,ds0io	;  0
		call	dswait480	; 480
		cbi	ds0ddr,ds0io	;   Z
		call	dswait88	; 88 
		sbis	ds0pin,ds0io	;  I/O
		ser	temp		;temp=255, DS 
		call	dswait480	; 480
		reti
dsinit1:	cli
		clr	temp		;temp=0
		cbi	ds1ddr,ds1io	;   Z
		sbis	ds1pin,ds1io	;  I/O
		reti			;   -
		sbi	ds1ddr,ds1io	; 
		cbi	ds1port,ds1io	;  0
		call	dswait480	; 480
		cbi	ds1ddr,ds1io	;   Z
		call	dswait88	; 88 
		sbis	ds1pin,ds1io	;  I/O
		ser	temp		;temp=255, DS 
		call	dswait480	; 480
		reti
dsinit2:	cli
		clr	temp		;temp=0
		cbi	ds2ddr,ds2io	;   Z
		sbis	ds2pin,ds2io	;  I/O
		reti			;   -
		sbi	ds2ddr,ds2io	; 
		cbi	ds2port,ds2io	;  0
		call	dswait480	; 480
		cbi	ds2ddr,ds2io	;   Z
		call	dswait88	; 88 
		sbis	ds2pin,ds2io	;  I/O
		ser	temp		;temp=255, DS 
		call	dswait480	; 480
		reti
dsinit3:	cli
		clr	temp		;temp=0
		cbi	ds3ddr,ds3io	;   Z
		sbis	ds3pin,ds3io	;  I/O
		reti			;   -
		sbi	ds3ddr,ds3io	; 
		cbi	ds3port,ds3io	;  0
		call	dswait480	; 480
		cbi	ds3ddr,ds3io	;   Z
		call	dswait88	; 88 
		sbis	ds3pin,ds3io	;  I/O
		ser	temp		;temp=255, DS 
		call	dswait480	; 480
		reti
dswait480:	push    temp		; 482.88
		push	temp1
		ser	temp
		ldi	temp1,5
dswait480i:	dec	temp
		brne	dswait480i
		dec	temp1
		brne	dswait480i
		pop	temp1
		pop	temp
		ret
dswait88:	push	temp		; 88.0
		ldi	temp,231
dswait88i:	dec	temp
		brne	dswait88i
		pop	temp
		ret
;//////////////////////////////////////////////////////////////////////////////
;     4-  DS1820 (8)
;    : temp
;     : temp1
;//////////////////////////////////////////////////////////////////////////////
dsread0:	ldi	temp1,0xFF	;   $FF
dswrite0:	push	temp3		;   
		cli
		ldi	temp3,8		; 8   
dswrite011:	sbi	ds0ddr,ds0io	;
		cbi	ds0port,ds0io	;  
		call	dswait2		; 2 
		ror	temp1		;    
		brcc	dswrite012	; , - 
		cbi	ds0ddr,ds0io	; 
dswrite012:	call	dswait9		; 9.8
		clc			; 
		sbic	ds0pin,ds0io	;  
		sec			;=1   =1
		ror	temp		;    
		call	dswait48	; 48 
		cbi	ds0ddr,ds0io	; 
		call	dswait2		; 2
		dec	temp3		;  -1
		brne	dswrite011	;   
		pop	temp3		; temp3
		sei
		ret
dsread1:	ldi	temp1,0xFF	;   $FF
dswrite1:	push	temp3		;   
		cli
		ldi	temp3,8		; 8   
dswrite111:	sbi	ds1ddr,ds1io	;
		cbi	ds1port,ds1io	;  
		call	dswait2		; 2 
		ror	temp1		;    
		brcc	dswrite112	; , - 
		cbi	ds1ddr,ds1io	; 
dswrite112:	call	dswait9		; 9.8
		clc			; 
		sbic	ds1pin,ds1io	;  
		sec			;=1   =1
		ror	temp		;    
		call	dswait48	; 48 
		cbi	ds1ddr,ds1io	; 
		call	dswait2		; 2
		dec	temp3		;  -1
		brne	dswrite111	;   
		pop	temp3		; temp3
		sei
		ret
dsread2:	ldi	temp1,0xFF	;   $FF
dswrite2:	push	temp3		;   
		cli
		ldi	temp3,8		; 8   
dswrite211:	sbi	ds2ddr,ds2io	;
		cbi	ds2port,ds2io	;  
		call	dswait2		; 2 
		ror	temp1		;    
		brcc	dswrite212	; , - 
		cbi	ds2ddr,ds2io	; 
dswrite212:	call	dswait9		; 9.8
		clc			; 
		sbic	ds2pin,ds2io	;  
		sec			;=1   =1
		ror	temp		;    
		call	dswait48	; 48 
		cbi	ds2ddr,ds2io	; 
		call	dswait2		; 2
		dec	temp3		;  -1
		brne	dswrite211	;   
		pop	temp3		; temp3
		sei
		ret
dsread3:	ldi	temp1,0xFF	;   $FF
dswrite3:	push	temp3		;   
		cli
		ldi	temp3,8		; 8   
dswrite311:	sbi	ds3ddr,ds3io	;
		cbi	ds3port,ds3io	;  
		call	dswait2		; 2 
		ror	temp1		;    
		brcc	dswrite312	; , - 
		cbi	ds3ddr,ds3io	; 
dswrite312:	call	dswait9		; 9.8
		clc			; 
		sbic	ds3pin,ds3io	;  
		sec			;=1   =1
		ror	temp		;    
		call	dswait48	; 48 
		cbi	ds3ddr,ds3io	; 
		call	dswait2		; 2
		dec	temp3		;  -1
		brne	dswrite311	;   
		pop	temp3		; temp3
		sei
		ret
dswait2:	push	temp		;  2us
		ldi	temp,1
dswait2i:	dec	temp
		nop
		nop
		brne	dswait2i
		pop	temp
		ret
		
dswait9:	push	temp		; 9.6us
		ldi	temp,22
dswait9i:	dec	temp
		brne	dswait9i
		pop	temp
		ret

dswait48:	push	temp		; 48.8us
		ldi	temp,126
dswait48i:	dec	temp
		brne	dswait48i
		pop	temp
		nop
		ret
;//////////////////////////////////////////////////////////////////////////////
;    DT0..DT2     SRAM
;//////////////////////////////////////////////////////////////////////////////
; DSEG:
;;  dsload
;;dt0:		.byte	2		;l:h    LTS
;;dt1:		.byte	2		;
;;dt2:		.byte	2		;
;;dt3:		.byte	2		;
;;d_fsmi:	.byte	1		;
;d_fsmi(x,x,x,x,d3,d2,d1,d0)- (=1  , 0- .
.equ		d0	=0		;
.equ		d1	=1		;
.equ		d2	=2		;
.equ		d3	=3		;
.equ		dsltout	=255		;    .
dsload:		
	;  0----------------------------------------
dsload_0: 	ldi 	temp1,dsltout
dsload_000:	dec	temp1
		breq	dsload_01
		call	dsinit0		;  0
	;    0
 		cpse 	temp,ffh
 		jmp  	dsload_000	
		jmp	dsload0		;	
	; 0 
dsload_01:	lds	temp,d_fsmi
		cbr	temp,(1<<d0)	;   
		sts	d_fsmi,temp
	;  1----------------------------------------
dsload_1:	ldi 	temp1,dsltout
dsload_111:	dec	temp1
		breq	dsload_11
		call	dsinit1		;  1
	;    1
		cpse 	temp,ffh
 		jmp  	dsload_111
		jmp	dsload1		;	
	; 1 
dsload_11:	lds	temp,d_fsmi
		cbr	temp,(1<<d1)		;   
		sts	d_fsmi,temp
	;  2----------------------------------------
dsload_2:	ldi 	temp1,dsltout
dsload_222:	dec	temp1
		breq	dsload_21
		call	dsinit2		;  2
	;    2
		cpse 	temp,ffh
 		jmp  	dsload_222
		jmp	dsload2		;
	; 2 
dsload_21:	lds	temp,d_fsmi
		cbr	temp,(1<<d2)	;   
		sts	d_fsmi,temp
	;  3----------------------------------------
dsload_3:	ldi 	temp1,dsltout
dsload_333:	dec	temp1
		breq	dsload_31
		call	dsinit3		;  3
	;    3
		cpse 	temp,ffh
 		jmp  	dsload_333
		jmp	dsload3		;	
	; 3 
dsload_31:	lds	temp,d_fsmi
		cbr	temp,(1<<d3)	;   
		sts	d_fsmi,temp
	;---------------------------------------------------------
dsload_e:	ret
	;  0
dsload0:	ldi	temp1,$cc	;$cc-  ROM 
		call	dswrite0	;  
		ldi	temp1,$44	;$44-  
		call	dswrite0
		ldi	temp1,dsltout	; 
dsload00:	dec	temp1
		brne	dsload0_0	
		jmp	dsload_01	;   
dsload0_0:	push	temp1
		call	w25ms
		call	dsread0		;   ds
		pop	temp1
		cpi	temp,$ff	; ?
		brne	dsload00	; - 
		call	dsinit0		;-    
		ldi	temp1,$cc	;$cc-  ROM  
		call	dswrite0	;  
		ldi	temp1,$be	; scratchpad
		call	dswrite0	;
		call	dsread0		;   LSB 
		mov	temp2,temp	; 
		call	dsread0		;   MSB 
		mov	temp3,temp	; 
		call	mlb2lts		;   LTS
		sts	dt0,xl		;  
		sts	dt0+1,xh	; 
		lds	temp,d_fsmi
		sbr	temp,(1<<d0)	;   
		sts	d_fsmi,temp
		jmp	dsload_1
	;  1
dsload1:	ldi	temp1,$cc	;$cc-  ROM 
		call	dswrite1	;  
		ldi	temp1,$44	;$44-  
		call	dswrite1
		ldi	temp1,dsltout	; 
dsload10:	dec	temp1
		brne	dsload1_0
		jmp	dsload_11
dsload1_0:	push	temp1
		call	w25ms		; DS
		call	dsread1		;   ds
		pop	temp1
		cpi	temp,$ff	; ?
		brne	dsload10	; - 
		call	dsinit1		;-    
		ldi	temp1,$cc	;$cc-  ROM  
		call	dswrite1	;  
		ldi	temp1,$be	; scratchpad
		call	dswrite1	;
		call	dsread1		;   LSB 
		mov	temp2,temp	; 
		call	dsread1		;   MSB 
		mov	temp3,temp	; 
		call	mlb2lts		;   LTS
		sts	dt1,xl		;  
		sts	dt1+1,xh	; 
		lds	temp,d_fsmi
		sbr	temp,(1<<d1)	;   
		sts	d_fsmi,temp
		jmp	dsload_2

	;  2
dsload2:	ldi	temp1,$cc	;$cc-  ROM 
		call	dswrite2	;  
		ldi	temp1,$44	;$44-  
		call	dswrite2
		ldi	temp1,dsltout	; 
dsload20:	dec	temp1
		brne	dsload2_0
		jmp	dsload_21	;   
dsload2_0:	push	temp1
		call	w25ms		;
		call	dsread2		;   ds
		pop	temp1
		cpi	temp,$ff	; ?
		brne	dsload20	; - 
		call	dsinit2		;-    
		ldi	temp1,$cc	;$cc-  ROM  
		call	dswrite2	;  
		ldi	temp1,$be	; scratchpad
		call	dswrite2	;
		call	dsread2		;   LSB 
		mov	temp2,temp	; 
		call	dsread2		;   MSB 
		mov	temp3,temp	; 
		call	mlb2lts		;   LTS
		sts	dt2,xl		;  
		sts	dt2+1,xh	; 
		lds	temp,d_fsmi
		sbr	temp,(1<<d2)		;   
		sts	d_fsmi,temp
		jmp	dsload_3
		
	;  3
dsload3:	ldi	temp1,$cc	;$cc-  ROM 
		call	dswrite3	;  
		ldi	temp1,$44	;$44-  
		call	dswrite3
		ldi	temp1,dsltout	; 
dsload30:	dec	temp1
		brne	dsload3_0
		jmp	dsload_31	;   
dsload3_0:	push	temp1
		call	w25ms		; 
		call	dsread3		;   ds
		pop	temp1
		cpi	temp,$ff	; ?
		brne	dsload30	; - 
		call	dsinit3		;-    
		ldi	temp1,$cc	;$cc-  ROM  
		call	dswrite3	;  
		ldi	temp1,$be	; scratchpad
		call	dswrite3	;
		call	dsread3		;   LSB 
		mov	temp2,temp	; 
		call	dsread3		;   MSB 
		mov	temp3,temp	; 
		call	mlb2lts		;   LTS
		sts	dt3,xl		;  
		sts	dt3+1,xh	; 
		lds	temp,d_fsmi
		sbr	temp,(1<<d3)	;   
		sts	d_fsmi,temp
		jmp	dsload_e
;//////////////////////////////////////////////////////////////////////////////
;   HEX -> BCD
; B :  X     --tmp0--
; B :    tmp2 tmp1 tmp0	7-4  3-0			    
;               0 6  5 5  3 5 	 3    5
;  : tmp0,tmp1,tmp2
;  : --- (   )
;//////////////////////////////////////////////////////////////////////////////		
bin2bcd16:	push	temp
		push	temp1
		push	xl
		push	xh
		push	zl
		push	zh
		ldi	temp1,16	; 
		clr	tmp2		;temp1- 
		clr	tmp1		; 
		clr	tmp0		; 
		clr	ZH		;
bbcdx_1:	lsl	XL		;  
		rol	XH		;
		rol	tmp0		; 
		rol	tmp1		;
		rol	tmp2		;
		dec	temp1		; 
		brne	bbcdx_2		;  
		pop	zh
		pop	zl
		pop	xh
		pop	xl
		pop	temp1
		pop	temp
		ret			;
bbcdx_2:	ldi	ZL,16		;MSB+1 (15+1)
bbcdx_3:	dec	ZL		; 
		ld	temp,Z		;ld  temp,-z
		subi	temp,-$03	; 
		sbrc	temp,3		;  3  
		st	Z,temp		; 
		ld	temp,Z		;
		subi	temp,-$30	; 
		sbrc	temp,7		;  7  
		st	Z,temp		; 
		cpi	ZL,13		;  ?
		brne	bbcdx_3		;,  
		jmp	bbcdx_1		;
;//////////////////////////////////////////////////////////////////////////////
;   MLB->LTS (  )
;  : temp2= LSB (+ 0..250) (- 255..145)
;                 temp3= MSB (+ 0)      (- 128)
; :       XH:XL= LTS 0(-55)...360(+125)(0.5)
;//////////////////////////////////////////////////////////////////////////////
mlb2lts:	push	temp2
		ldi	xl,110		; 
		clr	xh		;	
	;  
		tst	temp3		;MSB=0?
		breq	mlb2lts_pl	;
	; 	
		com	temp2		; 
		inc	temp2
	;	dec	temp2		;lsb=0b11111111  -0.5 
		sub	xl,temp2	;
		sbc	xh,zero		; 
		jmp	mlb2lts_ex	;
mlb2lts_pl:	add	xl,temp2	; 
		adc	xh,zero		; 16- 
		jmp	mlb2lts_ex	;
mlb2lts_ex:	pop	temp2
		ret
;//////////////////////////////////////////////////////////////////////////////
;   LTS->MLB
;  : XH:XL= LTS 0(-55)...360(+125)(0.5)
; :       temp2= LSB (+ 0..250) (- 255..145)
;                 temp3= MSB (+ 0)      (- 128)
;//////////////////////////////////////////////////////////////////////////////
lts2mlb:	push	xh
		push	xl
	;  
		cpi	xl,110		;,     ?
		cpc	xh,zero		; 
		brlo	lts2mlb_lo	; 
		breq	lts2mlb_zr	; 
	; 
		subi	xl,110		; 
		sbc	xh,zero		;  110
		mov	temp2,xl	;  
		clr	temp3		; 
		jmp	lts2mlb_ex	;
	;,  
lts2mlb_lo:	subi	xl,110		; 
		sbc	xh,zero		;  110
		mov	temp2,xl	;  255
		ldi	temp3,128	; 
		jmp	lts2mlb_ex	;
	; 
lts2mlb_zr:	clr	temp2		; ,
		clr	temp3		;   
lts2mlb_ex:	pop	xl
		pop	xh
		ret
;//////////////////////////////////////////////////////////////////////////////
; 
;  oss_keyinp,lcdprintf,lcdcom,lcddat
;//////////////////////////////////////////////////////////////////////////////
; DSEG:
;;  menu
;;m_rele_num:	.byte	1		;   
;;m_rele_s:	.byte	4		;  1-4
;;m_rele_p:	.byte	4		;  1-4
.equ		up	=0		; 
.equ		right	=1		;  
.equ		down	=2		;k_res0
.equ		left	=3		;. -  
.equ		enter	=4		;.
menu:
;   ----------------------------------------------------------------
m001:		call	releinit	;   - 
		call	clear
		lcdprintf	0,0,15,m001_
		lcdprintf	0,1,16,m_s
		call	keyoff
		call	anykey
		sbrs	temp,down
		jmp	m002
		sbrs	temp,enter
		jmp	m001_1		;   
		sbrs	temp,up
		jmp	m007
		jmp	m001
m001_1:		call	menusave	;  
		call	clear
		ret
; ----------------------------------------------------------------	
m002:		call	clear		;  
		lcdprintf	0,0,13,m002_
	;,    
		ldi	temp,low(contrast);   EEPROM
		out	EEARL,temp 	;  EEPROM
		out	EEARH,zero
		sbi	EECR,EERE	;  eeprom
m002_eer:	sbic	EECR,EERE	; 
		jmp	m002_eer	;
		in	temp,EEDR	;  
		in	temp1,ocr0	;  
		cp	temp,temp1	;
		breq	m002_i		;-  
		lcdprintf	3,1,13,m002_2;
		jmp	m002_next	;
m002_i:		lcdprintf	3,1,13,m002_3;
    ;   
m002_next:    	ldi	temp,192	;    .
    		call	lcdcom		; 
		in	temp,ocr0	;    OCR0
	;     239...200 -> 0...100%
		ldi	temp1,239	;    
		sub	temp1,temp	;239- temp=  . 
		ldi	zl,low(m002_tab*2)
		ldi	zh,high(m002_tab*2)
		add	zl,temp1	; 
		adc	zh,zero
		lpm			; 
		mov	xl,r0		;  bin2bcd 
		clr	xh		;  BCD
		call	bin2bcd16	;
		mov	temp,tmp1	; 
		andi	temp,0b00001111	;  
		ldi	temp1,48	; DEC - ASCII
		add	temp,temp1	; 
		call	lcddat		;
		mov	temp,tmp0	;
		swap	temp		; 
		andi	temp,0b00001111	;,
		add	temp,temp1	;  
		call	lcddat		;
		mov	temp,tmp0	;
		andi	temp,0b00001111 ; 
		add	temp,temp1	;
		call	lcddat		;
     ; 
		call	keyoff		;  
		call	anykey		;  
		sbrs	temp,down	; . 
		jmp	m004		;   
		sbrs	temp,up		;-
		jmp	m001		; 
		sbrs	temp,right	;-
		jmp	m002_r		; 
		sbrs	temp,left	;- 
		jmp	m002_l		;
		sbrs	temp,enter	;enter-
		jmp	m002_e		; 
		jmp	m002		;- -   
m002_r:		in	temp,ocr0	; -  
		ldi	temp1,200	;     ocr0
		cp	temp,temp1	; 200 -  
		breq	m002_rr		;. .
		dec	temp		;- 
		out	ocr0,temp	;   
m002_rr:	jmp	m002		;  
m002_l:		in	temp,ocr0	; -  
		ldi	temp1,239	;239- ,   
		cp	temp,temp1	;  . ,
		breq	m002_ll		; , 
		inc	temp		;    ocr0,
		out	ocr0,temp	;   
m002_ll:	jmp	m002		;
m002_e:		sbic	EECR,EEWE	;  EEPROM.
		jmp	m002_e		;  
		ldi	temp,low(contrast);   EEPROM
		out	EEARL,temp	;  EEPROM
		out	EEARH,zero	; -  
		in	temp,ocr0	;    
		out	EEDR,temp	;   
		cli
		sbi	EECR,EEMWE	; 
		nop			;  
		sbi	EECR,EEWE	; 
		sei
		jmp	m002		;,  
; 1 -----------------------------------------------------------------------
m004:		call	clear		; 
		lcdprintf	0,0,4,m_rele;
		ldi	temp,32		;
		call	lcddat
		ldi	temp,49		;1
		call	lcddat
		lcdprintf	0,1,6,menu_1
		ldi	temp,1
		sts	m_rele_num,temp
		call	keyoff
		call	anykey
		sbrs	temp,down
		jmp	m005
		sbrs	temp,up
		jmp	m002
		sbrs	temp,right
		jmp	m010x
		jmp	m004
; 2 -----------------------------------------------------------------------
m005:		call	clear		; 
		lcdprintf	0,0,4,m_rele	
		ldi	temp,32
		call	lcddat
		ldi	temp,50		;2
		call	lcddat
		lcdprintf	0,1,6,menu_1
		ldi	temp,2
		sts	m_rele_num,temp
		call	keyoff
		call	anykey
		sbrs	temp,down
		jmp	m006
		sbrs	temp,up
		jmp	m004
		sbrs	temp,right
		jmp	m010x
		jmp	m005
; 3 -----------------------------------------------------------------------
m006:		call	clear		; 
		lcdprintf	0,0,4,m_rele	
		ldi	temp,32		;
		call	lcddat
		ldi	temp,51		;3
		call	lcddat
		lcdprintf	0,1,6,menu_1
		ldi	temp,3
		sts	m_rele_num,temp
		call	keyoff
		call	anykey
		sbrs	temp,down
		jmp	m007
		sbrs	temp,up
		jmp	m005
		sbrs	temp,right
		jmp	m010x
		jmp	m006
; 4 -----------------------------------------------------------------------
m007:		call	clear		; 
		lcdprintf	0,0,4,m_rele	
		ldi	temp,32
		call	lcddat
		ldi	temp,52		;4
		call	lcddat
		lcdprintf	0,1,6,menu_1
		ldi	temp,4
		sts	m_rele_num,temp
		call	keyoff
		call	anykey
		sbrs	temp,down
		jmp	m001
		sbrs	temp,up
		jmp	m006
		sbrs	temp,right
		jmp	m010x
		jmp	m007
;  x ------------------------------------------------------------------
m010x:		call	clear		; 
		lcdprintf	0,0,4,m_rele;
		ldi	temp,32		;
		call	lcddat
		lds	temp,m_rele_num	;  
		subi	temp,-48	;   
		call	lcddat		;
		lcdprintf	7,0,4,menu_1; 
		ldi	temp,32
		call	lcddat		;
		ldi	temp,217
		call	lcddat		; 
		lcdprintf	0,1,14,m001_;    
		ldi	temp,0		; 
		call	lcddat
		call	keyoff		;  
		call	anykey		;  
		sbrs	temp,left	;  enter
		jmp	m010x_out	;   
		sbrs	temp,up		;  
		jmp	m011x		;   
		;------------
		jmp	m010x		;
m010x_out:	lds	temp,m_rele_num	;   
		cpi	temp,1
		breq	m004ss		;1
		cpi	temp,2
		breq	m005ss		;2
		cpi	temp,3
		breq	m006ss		;3
		cpi	temp,4		
		breq	m007ss		;4
		jmp	m010x
m004ss:		jmp	m004		;FAR 
m005ss:		jmp	m005		;FAR 
m006ss:		jmp	m006		;FAR 
m007ss:		jmp	m007		;FAR 
;  x -------------------------------------------------------------
m011x:		call	clear		; 
		lcdprintf	0,0,14,m_rele_sost
		ldi	temp,32
		call	lcddat		; 
		lds	temp,m_rele_num	;    
		push	temp		;   
		subi	temp,-48	;   
		call	lcddat		;  
		pop	temp		;   
		dec	temp		;1,2,3,4    0,1,2,3
		ldi	zl,low(m_rele_s);    
		ldi	zh,high(m_rele_s)
		add	zl,temp		; 
		adc	zh,zero
		ld	temp,z		;     temp
		cpi	temp,0		; 
		breq	m011x_s0	;  
		cpi	temp,1		;
		breq	m011x_s1	;  
		lcdprintf	0,1,14,m_rele_zam
		jmp	m011_sn	
m011x_s0:	lcdprintf	0,1,9,m_rele_off
		jmp	m011_sn
m011x_s1:	lcdprintf	0,1,16,m_rele_ras
m011_sn:	call	keyoff		;  
		call	anykey		;  
		lds	temp1,m_rele_num;    
		dec	temp1		;1,2,3,4    0,1,2,3
		ldi	zl,low(m_rele_s);    
		ldi	zh,high(m_rele_s)
		add	zl,temp1	; 
		adc	zh,zero
		ld	temp1,z		;     temp1
		sbrs	temp,down	;  
		jmp	m010x		;  
		sbrs	temp,right	;  
		jmp	m011x_ri
		sbrs	temp,left	;  
		jmp	m011x_le
		sbrs	temp,up		;  
		jmp	m012x		;   .
		jmp	m011x
m011x_ri:	cpi	temp1,2		;  
		brsh	m011xss		;    
		inc	temp1		;     3
		st	z,temp1		;  
		jmp	m011x		
m011x_le:	tst	temp1		;  
		breq	m011xss		;  .   
		dec	temp1		;  
		st	z,temp1		; 
m011xss:	jmp	m011x
;  . -------------------------------------------------------------
m012x:		lds	temp1,m_rele_num;    
		dec	temp1		;1,2,3,4    0,1,2,3
		ldi	zl,low(m_rele_s);    
		ldi	zh,high(m_rele_s)
		add	zl,temp1	; 
		adc	zh,zero
		ld	temp1,z		;     temp1
		tst	temp1		; -
		brne	m012xn
		jmp	m011x		; -   .
m012xn:		call	clear		; .
		lcdprintf	0,0,16,m003_;   .
		lcdprintf	0,1,4,m_rele;    
		lds	temp,m_rele_num	;    
		push	temp		;   
		subi	temp,-48	;   
		call	lcddat		;  
		lcdprintf	5,1,4,m_rdt; '- DT'
		ldi	zl,low(m_rele_p);    
		ldi	zh,high(m_rele_p)
		pop	temp		; temp-   
		dec	temp		;    
		add	zl,temp		;  
		adc	zh,zero
		ld	temp,z		;   
		push	temp		;   
		inc	temp		;    
		subi	temp,-48	;   
		call	lcddat		;   
		call	keyoff		;  
		call	anykey		;  
		pop	temp1		;   
		sbrs	temp,right	;  
		jmp	m012_ri
		sbrs	temp,left	; 
		jmp	m012_le
		sbrs	temp,down	;
		jmp	m011x
		sbrs	temp,up	
		jmp	m013x		;- 
		jmp	m012x		;
m012_ri:	cpi	temp1,3		;  
		brsh	m012_riss	;   3
		inc	temp1		;  1
		st	z,temp1		;  
m012_riss:	jmp	m012x
m012_le:	tst	temp1		;  
		breq	m012_riss	;  
		dec	temp1		; 1
		st	z,temp1		;   
		jmp	m012x
;   X ---------------------------------------------------
m013x:		call	clear		; 
		lcdprintf	0,0,16,m_niz_g_niz; ..
	;   nn   
		lds	temp1,m_rele_num;     
		dec	temp1		;    
		ldi	zl,low(m_nn_l)	; 
		ldi	zh,high(m_nn_l)	;
		add	zl,temp1	;
		adc	zh,zero		;  
		ld	xl,z		;  l
		adiw	zl,4		;  4
		ld	xh,z		;  h
	;    LTS,   MLB
		call	lts2mlb		;xh:xl -> temp3,temp2
	;    lcdprintt
		ldi	temp,5		;5- 
		sts	lpt_x,temp	
		ldi	temp,1		;1- 
		sts	lpt_y,temp
		call	lcdprintt	;  
	;    
		ldi	temp,192	;  
		call	lcdcom
		clr	temp		; 
		call	lcddat
		ldi	temp,207	;  
		call	lcdcom
		ldi	temp,1		; 
		call	lcddat
	; 
		call	keyof		;  
		call	anykey		;  
		sbrs	temp,left	;  
		jmp	m013_le		;  
		sbrs	temp,right	;  
		jmp	m013_ri		;  
		sbrs	temp,down	;  
		jmp	m012x		;   
		sbrs	temp,up		;   
		jmp	m014x
		jmp	m013x		;
	;   nv     Y
m013_ri:	lds	temp1,m_rele_num;     
		dec	temp1		;    
		ldi	zl,low(m_nv_l)	; 
		ldi	zh,high(m_nv_l)	;
		add	zl,temp1	;
		adc	zh,zero		;  
		ld	yl,z		;  l
		adiw	zl,4		;  4
		ld	yh,z		;  h
	;   nn     X
		lds	temp1,m_rele_num;     
		dec	temp1		;    
		ldi	zl,low(m_nn_l)	; 
		ldi	zh,high(m_nn_l)	;
		add	zl,temp1	;
		adc	zh,zero		;  
		ld	xl,z		;  l
		adiw	zl,4		;  4
		ld	xh,z		;  h
	;,     x    y
		cp	xl,yl		;16- 
		cpc	xh,yh		;
		brsh	m013_riex	;,   
		adiw	xl,1		;   1
		st	z,xh		;  h
		sbiw	zl,4		; 
		st	z,xl		;  L
m013_riex:	jmp	m013x
	;   nn     X
m013_le:	lds	temp1,m_rele_num;     
		dec	temp1		;    
		ldi	zl,low(m_nn_l)	; 
		ldi	zh,high(m_nn_l)	;
		add	zl,temp1	;
		adc	zh,zero		;  
		ld	xl,z		;  l
		adiw	zl,4		;  4
		ld	xh,z		;  h
	;,     x  
		cp	xl,zero		;16- 
		cpc	xh,zero		;
		breq	m013_leex	;,   
		sbiw	xl,1		;   1
		st	z,xh		;  h
		sbiw	zl,4		; 
		st	z,xl		;  L
m013_leex:	jmp	m013x
;   X ---------------------------------------------------
m014x:		call	clear		; 
		lcdprintf	0,0,16,m_niz_g_verx; ..
	;   nv   
		lds	temp1,m_rele_num;     
		dec	temp1		;    
		ldi	zl,low(m_nv_l)	; 
		ldi	zh,high(m_nv_l)	;
		add	zl,temp1	;
		adc	zh,zero		;  
		ld	xl,z		;  l
		adiw	zl,4		;  4
		ld	xh,z		;  h
	;    LTS,   MLB
		call	lts2mlb		;xh:xl -> temp3,temp2
	;    lcdprintt
		ldi	temp,5		;5- 
		sts	lpt_x,temp	
		ldi	temp,1		;1- 
		sts	lpt_y,temp
		call	lcdprintt	;  
	;    
		ldi	temp,192	;  
		call	lcdcom
		clr	temp		; 
		call	lcddat
		ldi	temp,207	;  
		call	lcdcom
		ldi	temp,1		; 
		call	lcddat
	; 
		call	keyof		;  
		call	anykey		;  
		sbrs	temp,left	;  
		jmp	m014_le		;  
		sbrs	temp,right	;  
		jmp	m014_ri		;  
		sbrs	temp,down	;  
		jmp	m013x		;   
		sbrs	temp,up		;   
		jmp	m015x
		jmp	m014x		;
	;   vn     Y
m014_ri:	lds	temp1,m_rele_num;     
		dec	temp1		;    
		ldi	zl,low(m_vn_l)	; 
		ldi	zh,high(m_vn_l)	;
		add	zl,temp1	;
		adc	zh,zero		;  
		ld	yl,z		;  l
		adiw	zl,4		;  4
		ld	yh,z		;  h
	;   nv     X
		lds	temp1,m_rele_num;     
		dec	temp1		;    
		ldi	zl,low(m_nv_l)	; 
		ldi	zh,high(m_nv_l)	;
		add	zl,temp1	;
		adc	zh,zero		;  
		ld	xl,z		;  l
		adiw	zl,4		;  4
		ld	xh,z		;  h
	;,     x    y
		cp	xl,yl		;16- 
		cpc	xh,yh		;
		brsh	m014_riex	;,   
		adiw	xl,1		;   1
		st	z,xh		;  h
		sbiw	zl,4		; 
		st	z,xl		;  L
m014_riex:	jmp	m014x
	;   nn     y
m014_le:	lds	temp1,m_rele_num;     
		dec	temp1		;    
		ldi	zl,low(m_nn_l)	; 
		ldi	zh,high(m_nn_l)	;
		add	zl,temp1	;
		adc	zh,zero		;  
		ld	yl,z		;  l
		adiw	zl,4		;  4
		ld	yh,z		;  h
	;   nv     X
		lds	temp1,m_rele_num;     
		dec	temp1		;    
		ldi	zl,low(m_nv_l)	; 
		ldi	zh,high(m_nv_l)	;
		add	zl,temp1	;
		adc	zh,zero		;  
		ld	xl,z		;  l
		adiw	zl,4		;  4
		ld	xh,z		;  h
	;,     y    x
		cp	yl,xl		;16- 
		cpc	yh,xh		;
		brsh	m014_leex	;,   
		sbiw	xl,1		;   1
		st	z,xh		;  h
		sbiw	zl,4		; 
		st	z,xl		;  L
m014_leex:	jmp	m014x
;   X ---------------------------------------------------
m015x:		call	clear		; 
		lcdprintf	0,0,16,m_verx_g_niz; ..
	;   vn   
		lds	temp1,m_rele_num;     
		dec	temp1		;    
		ldi	zl,low(m_vn_l)	; 
		ldi	zh,high(m_vn_l)	;
		add	zl,temp1	;
		adc	zh,zero		;  
		ld	xl,z		;  l
		adiw	zl,4		;  4
		ld	xh,z		;  h
	;    LTS,   MLB
		call	lts2mlb		;xh:xl -> temp3,temp2
	;    lcdprintt
		ldi	temp,5		;5- 
		sts	lpt_x,temp	
		ldi	temp,1		;1- 
		sts	lpt_y,temp
		call	lcdprintt	;  
	;    
		ldi	temp,192	;  
		call	lcdcom
		clr	temp		; 
		call	lcddat
		ldi	temp,207	;  
		call	lcdcom
		ldi	temp,1		; 
		call	lcddat
	; 
		call	keyof		;  
		call	anykey		;  
		sbrs	temp,left	;  
		jmp	m015_le		;  
		sbrs	temp,right	;  
		jmp	m015_ri		;  
		sbrs	temp,down	;  
		jmp	m014x		;   
		sbrs	temp,up		;   
		jmp	m016x
		jmp	m015x		;
	;   vv     Y
m015_ri:	lds	temp1,m_rele_num;     
		dec	temp1		;    
		ldi	zl,low(m_vv_l)	; 
		ldi	zh,high(m_vv_l)	;
		add	zl,temp1	;
		adc	zh,zero		;  
		ld	yl,z		;  l
		adiw	zl,4		;  4
		ld	yh,z		;  h
	;   vn     X
		lds	temp1,m_rele_num;     
		dec	temp1		;    
		ldi	zl,low(m_vn_l)	; 
		ldi	zh,high(m_vn_l)	;
		add	zl,temp1	;
		adc	zh,zero		;  
		ld	xl,z		;  l
		adiw	zl,4		;  4
		ld	xh,z		;  h
	;,     x    y
		cp	xl,yl		;16- 
		cpc	xh,yh		;
		brsh	m015_riex	;,   
		adiw	xl,1		;   1
		st	z,xh		;  h
		sbiw	zl,4		; 
		st	z,xl		;  L
m015_riex:	jmp	m015x
	;   nv     y
m015_le:	lds	temp1,m_rele_num;     
		dec	temp1		;    
		ldi	zl,low(m_nv_l)	; 
		ldi	zh,high(m_nv_l)	;
		add	zl,temp1	;
		adc	zh,zero		;  
		ld	yl,z		;  l
		adiw	zl,4		;  4
		ld	yh,z		;  h
	;   vn     X
		lds	temp1,m_rele_num;     
		dec	temp1		;    
		ldi	zl,low(m_vn_l)	; 
		ldi	zh,high(m_vn_l)	;
		add	zl,temp1	;
		adc	zh,zero		;  
		ld	xl,z		;  l
		adiw	zl,4		;  4
		ld	xh,z		;  h
	;,     y    x
		cp	yl,xl		;16- 
		cpc	yh,xh		;
		brsh	m015_leex	;,   
		sbiw	xl,1		;   1
		st	z,xh		;  h
		sbiw	zl,4		; 
		st	z,xl		;  L
m015_leex:	jmp	m015x
;   X ---------------------------------------------------
m016x:		call	clear		; 
		lcdprintf	0,0,16,m_verx_g_verx; ..
	;   vv   
		lds	temp1,m_rele_num;     
		dec	temp1		;    
		ldi	zl,low(m_vv_l)	; 
		ldi	zh,high(m_vv_l)	;
		add	zl,temp1	;
		adc	zh,zero		;  
		ld	xl,z		;  l
		adiw	zl,4		;  4
		ld	xh,z		;  h
	;    LTS,   MLB
		call	lts2mlb		;xh:xl -> temp3,temp2
	;    lcdprintt
		ldi	temp,5		;5- 
		sts	lpt_x,temp	
		ldi	temp,1		;1- 
		sts	lpt_y,temp
		call	lcdprintt	;  
	;    
		ldi	temp,192	;  
		call	lcdcom
		clr	temp		; 
		call	lcddat
		ldi	temp,207	;  
		call	lcdcom
		ldi	temp,1		; 
		call	lcddat
	; 
		call	keyof		;  
		call	anykey		;  
		sbrs	temp,left	;  
		jmp	m016_le		;  
		sbrs	temp,right	;  
		jmp	m016_ri		;  
		sbrs	temp,down	;  
		jmp	m015x		;   
		jmp	m016x		;	
	;   vn     X
m016_ri:	lds	temp1,m_rele_num;     
		dec	temp1		;    
		ldi	zl,low(m_vv_l)	; 
		ldi	zh,high(m_vv_l)	;
		add	zl,temp1	;
		adc	zh,zero		;  
		ld	xl,z		;  l
		adiw	zl,4		;  4
		ld	xh,z		;  h
	;,     x    360
		ldi	yl,low(360)	; 
		ldi	yh,high(360)	;360
		cp	xl,yl		;16- 
		cpc	xh,yh		;
		brsh	m016_riex	;,   
		adiw	xl,1		;   1
		st	z,xh		;  h
		sbiw	zl,4		; 
		st	z,xl		;  L
m016_riex:	jmp	m016x
	;   vn     y
m016_le:	lds	temp1,m_rele_num;     
		dec	temp1		;    
		ldi	zl,low(m_vn_l)	; 
		ldi	zh,high(m_vn_l)	;
		add	zl,temp1	;
		adc	zh,zero		;  
		ld	yl,z		;  l
		adiw	zl,4		;  4
		ld	yh,z		;  h
	;   vv     X
		lds	temp1,m_rele_num;     
		dec	temp1		;    
		ldi	zl,low(m_vv_l)	; 
		ldi	zh,high(m_vv_l)	;
		add	zl,temp1	;
		adc	zh,zero		;  
		ld	xl,z		;  l
		adiw	zl,4		;  4
		ld	xh,z		;  h
	;,     y    x
		cp	yl,xl		;16- 
		cpc	yh,xh		;
		brsh	m016_leex	;,   
		sbiw	xl,1		;   1
		st	z,xh		;  h
		sbiw	zl,4		; 
		st	z,xl		;  L
m016_leex:	jmp	m016x
;//////////////////////////////////////////////////////////////////////////////		
;    
;//////////////////////////////////////////////////////////////////////////////
keyoff:		push	temp
keyoff1:	lds	temp,k_res0	; 
		com	temp		;.. - 
		tst	temp		; 
		brne	keyoff1		;
		pop	temp
		ret
;//////////////////////////////////////////////////////////////////////////////
;     
;//////////////////////////////////////////////////////////////////////////////
; DSEG:
;;  keyof:
;;key_f:	.byte	1		; 
keyof:		push	temp		;
keyof_0:	lds	temp,k_res0	;   
		com	temp		;  - 
		tst	temp		;0- 
		brne	keyof_1		;  - 
		sts	key_f,zero	;-    
		jmp	keyof_ex	;
keyof_1:	com	temp		; ,   
		sbrs	temp,right	;
		jmp	keyof_2		;
		sbrs	temp,left	;
		jmp	keyof_2		;  
		sts	key_f,zero	;  
		jmp	keyof_0		;, 
keyof_2:	lds	temp,key_f	; 
		cpi	temp,3		; 
		brlo	keyof_3		;  ->3
		cpi	temp,10		;
		brlo	keyof_4		;10  ->4
		cpi	temp,30		;  30
		brlo	keyof_5		;-> 5   30-  ,  
		jmp	keyof_ex	; 
keyof_3:	push	temp		;
		ser	temp1		; 
		ser	temp2		; 0.2 
		ldi	temp3,5		;
keyof_wo2r:	lds	temp,k_res0	; 
		com	temp		;  
		tst	temp		; 
		breq	keyof_w02e	;  
		dec	temp1
		brne	keyof_wo2r	; 1
		dec	temp2
		brne	keyof_wo2r	; 2
		dec	temp3
		brne	keyof_wo2r	; 3
keyof_w02e:	pop	temp
		inc	temp		; 
		sts	key_f,temp	; -  
		jmp	keyof_ex	; 
keyof_4:	call	w01s		; 	
		inc	temp		;
		sts	key_f,temp	;
		jmp 	keyof_ex	;
keyof_5:	call	w25ms		;  
		inc	temp		;   
		sts	key_f,temp	;
keyof_ex:	pop	temp		; 
		ret
;//////////////////////////////////////////////////////////////////////////////		
;    
;//////////////////////////////////////////////////////////////////////////////
anykey:		lds	temp,k_res0	;  
		com	temp		;
		tst	temp		;
		breq	anykey		; ,(  )
		com	temp		;-  
		ret
;//////////////////////////////////////////////////////////////////////////////
;  
;//////////////////////////////////////////////////////////////////////////////
clear:		lcdprintf	0,0,16,mclr
		lcdprintf	0,1,16,mclr
		ret
mclr:		.db	"                "
;//////////////////////////////////////////////////////////////////////////////
;      PROM
;//////////////////////////////////////////////////////////////////////////////
menusave:	push	temp
		push	temp1
		push	temp2
		push	xl
		push	xh
		push	yl
		push	yh
	;   EEPROM
		ldi	yl,low(em_rele_s)
		ldi	yh,high(em_rele_s)
	;   SRAM
		ldi	xl,low(m_rele_s)
		ldi	xh,high(m_rele_s)
	;    EEPROM
		ldi	temp2,40		; 
menus_new:	cli
		out	eearl,yl		; 
		out	eearh,yh		;
	   	sbi	eecr,eere		;
menus_eer:	sbic	eecr,eere		; 
		jmp	menus_eer
		in	temp,eedr		;  EEP -> temp
		sei
		ld	temp1,x			;  SRAM-> temp1
		cp	temp,temp1		;  
		breq	menusave_no		;-  
	;  SRAM  
		cli
		out	eedr,temp1		;  .SRAM  EEDR
		sbi	eecr,eemwe		;  
		nop				;
		sbi	eecr,eewe		; 
menus_eew:	sbic	eecr,eewe		; 
		jmp	menus_eew		;loop
		sei
menusave_no:	adiw	xl,1			; SRAM +1
		adiw	yl,1			; EEPROM +1
		dec	temp2			; -1
		brne	menus_new		;
		pop	yh
		pop	yl
		pop	xh
		pop	xl
		pop	temp2
		pop	temp1
		pop	temp
		ret
;//////////////////////////////////////////////////////////////////////////////
;    PROM
;//////////////////////////////////////////////////////////////////////////////
menuload:	push	temp
		push	temp2
		push	xl
		push	xh
		push	yl
		push	yh
	;   EEPROM
		ldi	yl,low(em_rele_s)
		ldi	yh,high(em_rele_s)
	;   SRAM
		ldi	xl,low(m_rele_s)
		ldi	xh,high(m_rele_s)
	;
		ldi	temp2,40		; 
menulo_1:	out	eearl,yl		; 
		out	eearh,yh		;
		cli
	   	sbi	eecr,eere		;
menulo_eer:	sbic	eecr,eere		; 
		jmp	menulo_eer
		in	temp,eedr		;  EEP -> temp
		sei
		st	x,temp			;  
		adiw	xl,1			; SRAM +1
		adiw	yl,1			; EEPROM +1
		dec	temp2			; -1
		brne	menulo_1		;
		pop	yh
		pop	yl
		pop	xh
		pop	xl
		pop	temp2
		pop	temp
		ret
;//////////////////////////////////////////////////////////////////////////////
;    .
;  :	m_nn_l, m_nn_h
;			m_nv_l, m_nv_h
;			m_vn_l,	m_vn_h
;			m_vv_l,	m_vv_h
;  :	h_f0 [0- 1- , 2- ]
;			h_f1
;			h_f2
;			h_f3
;			r_fsmi(x,x,x,x,re3,re2,re1,re0)- 
;  :  XL,XH,AL,AH,BL,BH,YL,YH,ZL,ZH !!!!!!!!!!!!!!!!!!!!!!!!
;//////////////////////////////////////////////////////////////////////////////
; DSEG:
;;  testhyst  inithyst
;;h_f0:		.byte	1		; 0   0- .
;;h_f1:		.byte	1		; 1   0- .
;;h_f2:		.byte	1		; 2   0- .
;;h_f3:		.byte	1		; 3   0- .
;;r_fsmi(x,x,x,x,re3,re2,re1,re0)-   
.equ		re0	=0
.equ		re1	=1
.equ		re2	=2
.equ		re3	=3
testhyst:	push	temp
		push	temp1
;   1.
testhyst01:
	;     ?
		lds	temp,(m_rele_s+re0);  
		tst	temp		;   - 
		breq	testhyst01e	; - 
	;,  ,  -   ?
		lds	temp,(m_rele_p+re0);   
	;,    ..
		lds	temp1,d_fsmi	;  
;		ldi	zl,low(mask*2)	;   
;		ldi	zh,high(mask*2)	;  
		add	zl,temp		;   
		adc	zh,zero		; 
		lpm			; 
		and	temp1,r0	; ,    
		tst	temp1		;- -  .
		breq	testhyst01e	;     
	;  . -,   .
	;     X  , .  m_rele_p+re(x)
		ldi	zl,low(dt0)	; 
		ldi	zh,high(dt0)	;
		lsl	temp		;temp*2
		add	zl,temp		; 
		adc	zh,zero		;,  16-.
		ld	xl,z+		;    
		ld	xh,z		; 
	;       ( ).
		lds	temp,h_f0	; .    1 
	;,  XH:XL    LTS  ,  temp-  .
		lds	al,(m_nn_l+re0)
		lds	ah,(m_nn_h+re0)	;H0
		lds	bl,(m_nv_l+re0)
		lds	bh,(m_nv_h+re0)	;H1
		lds	yl,(m_vn_l+re0)
		lds	yh,(m_vn_h+re0)	;H2
		lds	zl,(m_vv_l+re0)
		lds	zh,(m_vv_h+re0)	;H3
	;  : x-X, h0-A, h1-B, h2-Y, h3-Z, temp- .
		call	testhyst0	;   
	;  
		sts	h_f0,temp	;
	; r_fsmi-  
		lds	temp1,r_fsmi	;  
		tst	temp		;0-  , - 
		breq	testhyst01v	; ------------
		cbr	temp1,(1<<re0)	;   0-----------------
testhyst01vv:	sts	r_fsmi,temp1	;---------------
		jmp	testhyst02	;--------------------
testhyst01v:	sbr	temp1,(1<<re0)	;-----------------
		jmp	testhyst01vv	;------------------
;      
testhyst01e:	lds	temp,r_fsmi	;  . . 
		cbr	temp,(1<<re0)	;
		sts	r_fsmi,temp	; 
		ldi	temp,1		;1-  
		sts	h_f0,temp	;
;   2.
testhyst02:
	;     ?
		lds	temp,(m_rele_s+re1);  ---------------------
		tst	temp		;   - 
		breq	testhyst02e	; - ----------------------
	;,  ,  -   ?
		lds	temp,(m_rele_p+re1);   ---------------
	;,    ..
		lds	temp1,d_fsmi	;  
;		ldi	zl,low(mask*2)	;   
;		ldi	zh,high(mask*2)	;  
		add	zl,temp		;   
		adc	zh,zero		; 
		lpm			; 
		and	temp1,r0	; ,    
		tst	temp1		;- -  .
		breq	testhyst02e	;     --------------
	;  . -,   .
	;     X  , .  m_rele_p+re(x)
		ldi	zl,low(dt0)	; 
		ldi	zh,high(dt0)	;
		lsl	temp		;temp*2
		add	zl,temp		; 
		adc	zh,zero		;,  16-.
		ld	xl,z+		;    
		ld	xh,z		; 
	;       ( ).
		lds	temp,h_f1	; .    x ----------
	;,  XH:XL    LTS  ,  temp-  .
		lds	al,(m_nn_l+re1)	;		---------
		lds	ah,(m_nn_h+re1)	;H0		---------
		lds	bl,(m_nv_l+re1)	;		---------
		lds	bh,(m_nv_h+re1)	;H1		---------
		lds	yl,(m_vn_l+re1)	;		---------
		lds	yh,(m_vn_h+re1)	;H2		---------
		lds	zl,(m_vv_l+re1)	;		---------
		lds	zh,(m_vv_h+re1)	;H3		---------
	;  : x-X, h0-A, h1-B, h2-Y, h3-Z, temp- .
		call	testhyst0	;   
	;  
		sts	h_f1,temp	;------------
	; r_fsmi-  
		lds	temp1,r_fsmi	;  
		tst	temp		;0-  , - 
		breq	testhyst02v	; ------------
		cbr	temp1,(1<<re1)	;   0-----------------
testhyst02vv:	sts	r_fsmi,temp1	;---------------
		jmp	testhyst03	;--------------------
testhyst02v:	sbr	temp1,(1<<re1)	;-----------------
		jmp	testhyst02vv	;------------------
;      
testhyst02e:	lds	temp,r_fsmi	;  . . ------------------
		cbr	temp,(1<<re1)	;---------------------
		sts	r_fsmi,temp	; 
		ldi	temp,1		;1-  
		sts	h_f1,temp	;-----------------
;   3.
testhyst03:
	;     ?
		lds	temp,(m_rele_s+re2);  ---------------------
		tst	temp		;   - 
		breq	testhyst03e	; - ----------------------
	;,  ,  -   ?
		lds	temp,(m_rele_p+re2);   ---------------
	;,    ..
		lds	temp1,d_fsmi	;  
;		ldi	zl,low(mask*2)	;   
;		ldi	zh,high(mask*2)	;  
		add	zl,temp		;   
		adc	zh,zero		; 
		lpm			; 
		and	temp1,r0	; ,    
		tst	temp1		;- -  .
		breq	testhyst03e	;     --------------
	;  . -,   .
	;     X  , .  m_rele_p+re(x)
		ldi	zl,low(dt0)	; 
		ldi	zh,high(dt0)	;
		lsl	temp		;temp*2
		add	zl,temp		; 
		adc	zh,zero		;,  16-.
		ld	xl,z+		;    
		ld	xh,z		; 
	;       ( ).
		lds	temp,h_f2	; .    x ----------
	;,  XH:XL    LTS  ,  temp-  .
		lds	al,(m_nn_l+re2)	;		---------
		lds	ah,(m_nn_h+re2)	;H0		---------
		lds	bl,(m_nv_l+re2)	;		---------
		lds	bh,(m_nv_h+re2)	;H1		---------
		lds	yl,(m_vn_l+re2)	;		---------
		lds	yh,(m_vn_h+re2)	;H2		---------
		lds	zl,(m_vv_l+re2)	;		---------
		lds	zh,(m_vv_h+re2)	;H3		---------
	;  : x-X, h0-A, h1-B, h2-Y, h3-Z, temp- .
		call	testhyst0	;   
	;  
		sts	h_f2,temp	;------------
	; r_fsmi-  
		lds	temp1,r_fsmi	;  
		tst	temp		;0-  , - 
		breq	testhyst03v	; ------------
		cbr	temp1,(1<<re2)	;   0-----------------
testhyst03vv:	sts	r_fsmi,temp1	;---------------
		jmp	testhyst04	;--------------------
testhyst03v:	sbr	temp1,(1<<re2)	;-----------------
		jmp	testhyst03vv	;------------------
;      
testhyst03e:	lds	temp,r_fsmi	;  . . ------------------
		cbr	temp,(1<<re2)	;---------------------
		sts	r_fsmi,temp	; 
		ldi	temp,1		;1-  
		sts	h_f2,temp	;------------------
;   4.
testhyst04:
	;     ?
		lds	temp,(m_rele_s+re3);  ---------------------
		tst	temp		;   - 
		breq	testhyst04e	; - ----------------------
	;,  ,  -   ?
		lds	temp,(m_rele_p+re3);   ---------------
	;,    ..
		lds	temp1,d_fsmi	;  
;		ldi	zl,low(mask*2)	;   
;		ldi	zh,high(mask*2)	;  
		add	zl,temp		;   
		adc	zh,zero		; 
		lpm			; 
		and	temp1,r0	; ,    
		tst	temp1		;- -  .
		breq	testhyst04e	;     --------------
	;  . -,   .
	;     X  , .  m_rele_p+re(x)
		ldi	zl,low(dt0)	; 
		ldi	zh,high(dt0)	;
		lsl	temp		;temp*2
		add	zl,temp		; 
		adc	zh,zero		;,  16-.
		ld	xl,z+		;    
		ld	xh,z		; 
	;       ( ).
		lds	temp,h_f3	; .    x ----------
	;,  XH:XL    LTS  ,  temp-  .
		lds	al,(m_nn_l+re3)	;		---------
		lds	ah,(m_nn_h+re3)	;H0		---------
		lds	bl,(m_nv_l+re3)	;		---------
		lds	bh,(m_nv_h+re3)	;H1		---------
		lds	yl,(m_vn_l+re3)	;		---------
		lds	yh,(m_vn_h+re3)	;H2		---------
		lds	zl,(m_vv_l+re3)	;		---------
		lds	zh,(m_vv_h+re3)	;H3		---------
	;  : x-X, h0-A, h1-B, h2-Y, h3-Z, temp- .
		call	testhyst0	;   
	;  
		sts	h_f3,temp	;------------
	; r_fsmi-  
		lds	temp1,r_fsmi	;  
		tst	temp		;0-  , - 
		breq	testhyst04v	; ------------
		cbr	temp1,(1<<re3)	;   0-----------------
testhyst04vv:	sts	r_fsmi,temp1	;---------------
		jmp	testhyst_ret	;--------------------
testhyst04v:	sbr	temp1,(1<<re3)	;-----------------
		jmp	testhyst04vv	;------------------
;      
testhyst04e:	lds	temp,r_fsmi	;  . . ------------------
		cbr	temp,(1<<re3)	;---------------------
		sts	r_fsmi,temp	; 
		ldi	temp,1		;1-  
		sts	h_f3,temp	;------------------
testhyst_ret:	pop	temp1
		pop	temp
		ret
	;  	
testhyst0:	tst	temp		; F=0?
		breq	testhyst0_01
		cpi	temp,1		; F=1?
		breq	testhyst0_04
		cpi	temp,2		; F=2?
		breq	testhyst0_05
		ldi	temp,1		;,
		jmp	testhyst0_ret	;   
	; F0
testhyst0_01:	cp	zl,xl
		cpc	zh,xh		;x>h3
		brlo	testhyst0_02
		breq	testhyst0_02	;x=h3
		cp	xl,al
		cpc	xh,ah		;x<h0?
		brlo	testhyst0_03
		breq	testhyst0_03	;x=h0?
		jmp	testhyst0_ret
testhyst0_02:	ldi	temp,2		;F=2
		jmp	testhyst0_ret
testhyst0_03:	ldi	temp,1		;F=1
		jmp	testhyst0_ret	
testhyst0_04:	cp	bl,al		;H1=H0?
		cpc	bh,ah		;
		breq	testhyst0_06	;
		cp	bl,xl
		cpc	bh,xh		;x>h1?
		brlo	testhyst0_07	;
		breq	testhyst0_07	;x=h1?
		jmp	testhyst0_ret
testhyst0_07:	clr	temp		;F=0
		jmp	testhyst0_ret
testhyst0_06:	cp	bl,xl
		cpc	bh,xh		;x>h1?
		brlo	testhyst0_07	;
		jmp	testhyst0_ret
testhyst0_05:	cp	zl,yl
		cp	zh,yh		;h3=h2?
		breq	testhyst0_08
		cp	xl,yl
		cpc	xh,yh		;x<h2?
		brlo	testhyst0_07
		breq	testhyst0_07	;x=h2?
		jmp	testhyst0_ret
testhyst0_08:	cp	xl,yl
		cpc	xh,yh		;x<h2?
		brlo	testhyst0_07
testhyst0_ret:	ret
;//////////////////////////////////////////////////////////////////////////////
;    
;  :
;  :
;//////////////////////////////////////////////////////////////////////////////
inithyst:	push	temp
		ldi	temp,1		;-  
		sts	h_f0,temp
		sts	h_f1,temp
		sts	h_f2,temp
		sts	h_f3,temp
		pop	temp
		ret
;//////////////////////////////////////////////////////////////////////////////
;   1,2,3,4
;  :	r_fsmi -  
;			m_rele_s -     
; :		 
;//////////////////////////////////////////////////////////////////////////////
;   0
.equ		re0port	=portd		;
.equ		re0ddr	=ddrd		; 
.equ		re0pin	=pind		;
.equ		re0io	=pd4		;  
;   1
.equ		re1port	=portd		;
.equ		re1ddr	=ddrd		; 
.equ		re1pin	=pind		;
.equ		re1io	=pd5		;  
;   2
.equ		re2port	=portd		;
.equ		re2ddr	=ddrd		; 
.equ		re2pin	=pind		;
.equ		re2io	=pd6		;  
;   3
.equ		re3port	=portd		;
.equ		re3ddr	=ddrd		; 
.equ		re3pin	=pind		;
.equ		re3io	=pd7		;  
rele:		
;  (  )
		sbi	re0ddr,re0io	;0
		sbi	re1ddr,re1io	;1
		sbi	re2ddr,re2io	;2
		sbi	re3ddr,re3io	;3
;  
		lds	temp,r_fsmi	; 
;  0--------------------------------------------------------------
	;  
		lds	temp1,(m_rele_s+re0);   
		tst	temp1		;  
		breq	rele0_off	;-   .
		cpi	temp1,2		;   
		breq	rele0_inv	;
		brlo	rele0_nor	; 
	;   
rele0_nor:	sbrc	temp,re0	;
		sbi	re0port,re0io	;
		sbrs	temp,re0	;
		cbi	re0port,re0io	;
		jmp	rele0_next
	;   	
rele0_inv:	sbrc	temp,re0	;
		cbi	re0port,re0io	;
		sbrs	temp,re0	;
		sbi	re0port,re0io	;
		jmp	rele0_next
	;  
rele0_off:	cbi	re0port,re0io	;
rele0_next:
;  1--------------------------------------------------------------
;  
		lds	temp1,(m_rele_s+re1);   
		tst	temp1		;  
		breq	rele1_off	;-   .
		cpi	temp1,2		;   
		breq	rele1_inv	;
		brlo	rele1_nor	; .2
	;   
rele1_nor:	sbrc	temp,re1	;
		sbi	re1port,re1io	;
		sbrs	temp,re1	;
		cbi	re1port,re1io	;
		jmp	rele1_next
	;   	
rele1_inv:	sbrc	temp,re1	;
		cbi	re1port,re1io	;
		sbrs	temp,re1	;
		sbi	re1port,re1io	;
		jmp	rele1_next
	;  
rele1_off:	cbi	re1port,re1io	;
rele1_next:
;  2--------------------------------------------------------------
;  
		lds	temp1,(m_rele_s+re2);   
		tst	temp1		;  
		breq	rele2_off	;-   .
		cpi	temp1,2		;   
		breq	rele2_inv	;
		brlo	rele2_nor	; .2
	;   
rele2_nor:	sbrc	temp,re2	;
		sbi	re2port,re2io	;
		sbrs	temp,re2	;
		cbi	re2port,re2io	;
		jmp	rele2_next
	;   	
rele2_inv:	sbrc	temp,re2	;
		cbi	re2port,re2io	;
		sbrs	temp,re2	;
		sbi	re2port,re2io	;
		jmp	rele2_next
	;  
rele2_off:	cbi	re2port,re2io	;
rele2_next:
;  3--------------------------------------------------------------
;  
		lds	temp1,(m_rele_s+re3);   
		tst	temp1		;  
		breq	rele3_off	;-   .
		cpi	temp1,2		;   
		breq	rele3_inv	;
		brlo	rele3_nor	; .2
	;   
rele3_nor:	sbrc	temp,re3	;
		sbi	re3port,re3io	;
		sbrs	temp,re3	;
		cbi	re3port,re3io	;
		jmp	rele3_next
	;   	
rele3_inv:	sbrc	temp,re3	;
		cbi	re3port,re3io	;
		sbrs	temp,re3	;
		sbi	re3port,re3io	;
		jmp	rele3_next
	;  
rele3_off:	cbi	re3port,re3io	;
rele3_next:
		ret
;//////////////////////////////////////////////////////////////////////////////
;   
;//////////////////////////////////////////////////////////////////////////////
releinit:	sbi	re0ddr,re0io	;0
		sbi	re1ddr,re1io	;1
		sbi	re2ddr,re2io	;2
		sbi	re3ddr,re3io	;3
		cbi	re0port,re0io	;0
		cbi	re1port,re1io	;1
		cbi	re2port,re2io	;2
		cbi	re3port,re3io	;3
		ret
;//////////////////////////////////////////////////////////////////////////////
;  
;//////////////////////////////////////////////////////////////////////////////
reset:		ldi	temp,low(RAMEND)
		out	SPL,temp
		ldi	temp,high(RAMEND);
		out	SPH,temp	; 
; 
		clr	zero		;  
		ldi	temp,1
		mov	one,temp	;=1
		ldi	temp,$ff
		mov	ffh,temp	; 255
		clr	post		;
; SRAM
		ldi	temp,low(SEND-RAMBEG+1); 9 
		ldi	zl,low(RAMBEG)	; 
		ldi	zh,high(RAMBEG)	; 
initramover:	st	z+,zero		; 
		dec	temp		;
		brne	initramover	; ?
;  SLEEP
		in	temp,MCUCR	; 
		sbr	temp,(1<<se)	;SLEEP 
		cbr	temp,(1<<sm0)	
		cbr	temp,(1<<sm1)
		cbr	temp,(1<<sm2)	; IDLE
;		sbr	temp,(1<<sm)	; POWER DOWN
		out	MCUCR,temp	;
;  :
;		call	w02s
; INT0,INT1
;		in	temp,MCUCR
;		cbr	temp,(1<<isc01)+(1<<isc00)
;		cbr	temp,(1<<isc11)+(1<<isc00)
;		out	MCUCR,temp	;  0
;:
		call	portinit	;	
		call	osrinit_t0	;osr,PWM
		sbi	ACSR,ACD	; 
; 		
		sbr	post,(1<<keyinp)
; OSR   
		sei
;    
		call	w01s		;  
;  LCD    
            	ldi	temp,low(contrast)
		out	EEARL,temp 	;  EEPROM
		out	EEARH,zero
		sbi	EECR,EERE	;  eeprom
res_eer:	sbic	EECR,EERE	; 
		jmp	res_eer		;
		in	temp,EEDR	;  
		out	ocr0,temp
; LCD
		call	lcdreset	; LCD
		call	lcdreset
;  G-  
		ldi	temp,$40	;  
		call	lcdcom		;
		ldi	zl,low(tab*2)	;
		ldi	zh,high(tab*2)	;
		ldi	temp1,64
d11:		lpm
		mov	temp,r0
		call	lcddat
		adiw	zl,1
		dec	temp1
		brne	d11
; 
		call	inithyst
;   
		call	menuload
;//////////////////////////////////////////////////////////////////////////////
;  
;//////////////////////////////////////////////////////////////////////////////
domain:		
;    
		ldi	temp,135
		call	lcdcom
		ldi	temp,' '	;
		call	lcddat
		ldi	temp,136
		call	lcdcom
		ldi	temp,' '	;
		call	lcddat
		ldi	temp,199
		call	lcdcom
		ldi	temp,' '	;
		call	lcddat
		ldi	temp,200
		call	lcdcom
		ldi	temp,' '	;
		call	lcddat
;    
		call	dsload		;
; 
		call	testhyst	;
; 
		call	rele		;
		
;+----------------+ +----------------+
;| DT1       DT2  | |+12.5`C  +18.0`C|
;| DT3       DT4  | |-22.0`C  -14.5`C|
;+----------------+ +----------------+

;   DT1  
	;,   
outdt0:		lds	temp,d_fsmi	; 
		sbrs	temp,d0		; 
		jmp	dt0off		; ,  --------
; , 
dt0on:		lds	xl,dt0		;
		lds	xh,dt0+1	;
		call	lts2mlb		;   
		ldi	temp,0		;x=0
		sts	lpt_x,temp
		ldi	temp,0		;y=0
		sts	lpt_y,temp
		call	lcdprintt	; 	
		jmp	outdt1		;
; ,  ---------
dt0off:		lcdprintf 0,0,7,doff	; "-------"
				
;   DT2  
	;,   
outdt1:		lds	temp,d_fsmi	; 
		sbrs	temp,d1		; 
		jmp	dt1off		; ,  --------
; , 
dt1on:		lds	xl,dt1		;
		lds	xh,dt1+1	;
		call	lts2mlb		;   
		ldi	temp,9		;x=9
		sts	lpt_x,temp
		ldi	temp,0		;y=0
		sts	lpt_y,temp
		call	lcdprintt	; 	
		jmp	outdt2		;
; ,  ---------
dt1off:		lcdprintf 9,0,7,doff	; "		
		

;   DT3  
	;,   
outdt2:		lds	temp,d_fsmi	; 
		sbrs	temp,d2		; 
		jmp	dt2off		; ,  --------
; , 
dt2on:		lds	xl,dt2		;
		lds	xh,dt2+1	;
		call	lts2mlb		;   
		ldi	temp,0		;x=0
		sts	lpt_x,temp
		ldi	temp,1		;y=0
		sts	lpt_y,temp
		call	lcdprintt	; 	
		jmp	outdt3		;
; ,  ---------
dt2off:		lcdprintf 0,1,7,doff	; "

;   DT4  
	;,   
outdt3:		lds	temp,d_fsmi	; 
		sbrs	temp,d3		; 
		jmp	dt3off		; ,  --------
; , 
dt3on:		lds	xl,dt3		;
		lds	xh,dt3+1	;
		call	lts2mlb		;   
		ldi	temp,9		;x=0
		sts	lpt_x,temp
		ldi	temp,1		;y=0
		sts	lpt_y,temp
		call	lcdprintt	; 	
		jmp	next		;
; ,  ---------
dt3off:		lcdprintf 9,1,7,doff	; "


next:			
;   Enter (  )
		lds	temp,k_res0	;  
		sbrs	temp,enter	;  enter
		call	menu		; - 
		call	keyoff		;  
	
	
	;  
		jmp	domain
;//////////////////////////////////////////////////////////////////////////////
;    
;//////////////////////////////////////////////////////////////////////////////
tab:		.db     0, 4, 8, 31, 8, 4, 0, 0
                .db     0, 4, 2, 31, 2, 4, 0, 0
                .db     14, 10, 14, 0, 0, 0, 0, 0
                .db     0, 0, 0, 0, 0, 0, 0, 0
                .db     0, 0, 0, 0, 0, 0, 0, 0
                .db     0, 0, 0, 0, 0, 0, 0, 0
                .db     0, 0, 0, 0, 0, 0, 0, 0
                .db     0, 0, 0, 0, 0, 0, 0, 0
mask1:		.db	1,2,4,8,16,32,64,128; 
m002_:		.db	75,111,189,191,112,97,99,191,189,111,99,191,196,32;
m002_2:		.db	37,32,126,45,67,111,120,112,97,189,184,191,196,0;% _-
m002_3:		.db	37,32,32,32,67,111,120,112,97,189,101,189,111,0;    
m002_tab:	.db	0,3,5,8,10,13,15,18,21,23,26,28,31,33,36,38,41,44;
		.db	46,49,51,54,56,59,62,64,67,69,72,74,77,79,82,85	;   .
		.db	87,90,92,95,97,100
menu_1:		.db	77,101,189,198,32,1; ->
m_rele:		.db	80,101,187,101;
m003_:		.db	168,112,184,179,199,183,186,97,32,186,32,227,97,191,192,46;  .
m_rdt:		.db	"- DT"
m001_:		.db	66,195,120,111,227,32,184,183,32,188,101,189,198,32,126,32;  
m_s:		.db	67,111,120,112,97,189,101,189,184,101,32,183,189,97,192,46; .
m_rele_sost:	.db	67,111,99,191,111,199,189,184,101,32,112,101,187,101; 
m_rele_off:	.db	79,191,186,187,198,192,101,189,111,32;O
m_rele_ras:	.db	72,111,112,188,46,112,97,183,111,188,186,189,121,191,111,32;.
m_rele_zam:	.db	72,111,112,188,46,183,97,188,186,189,121,191,111,32;.
m_verx_g_verx:	.db	66,101,112,120,46,180,184,99,191,46,179,101,112,120,46,32;...
m_verx_g_niz:	.db	66,101,112,120,46,180,184,99,191,46,189,184,182,189,46,32;...
m_niz_g_verx:	.db	72,184,182,189,46,180,184,99,191,46,179,101,112,120,46,32;...
m_niz_g_niz:	.db	72,184,182,189,46,180,184,99,191,46,189,184,182,189,46,32;...
doff:		.db	"--------";    
kad:		.db	"**"
kad_:		.db	"  "
programm:	.db	"m16term4ds1820Lcd.asm "


	
